; GUI #
include win64a.inc
; --------------- 
WINDOWWIDTH  = 656
WINDOWHEIGHT = 518
;numtriangles = 36
BITMAPFILEHEADER STRUCT
  bfType        dw ?
  bfSize        dd ?
  bfReserved1   dw ?
  bfReserved2   dw ?
  bfOffBits     dd ?
BITMAPFILEHEADER ENDS
BITMAPINFOHEADER STRUCT
  biSize          dd ?
  biWidth         dd ?
  biHeight        dd ?
  biPlanes        dw ?
  biBitCount      dw ?
  biCompression   dd ?
  biSizeImage     dd ?
  biXPelsPerMeter dd ?
  biYPelsPerMeter dd ?
  biClrUsed       dd ?
  biClrImportant  dd ?
BITMAPINFOHEADER ENDS
VERTEX	struct
	x dd ?
	y dd ?
	z dd ?
	u dd ?
	v_ dd ?;size=4*5=20
VERTEX	ends
TRIANGLE struct
 vertex VERTEX 3 dup (<>);3*20=60
TRIANGLE ends
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC)shl 32 \
	or (sizeof WNDCLASSEX)
	push	rax	;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or \
	WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0	
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD
local	ps:PAINTSTRUCT
local	w:dword
local	h:dword
local	FSize:dword
local	szReadWrite:QWORD	;number of bytes actually read or write
LOCAL	x_m:dword 
local	y_m:dword 
local	z_m:dword 
local	u_m:dword 
local	v_m:dword 
LOCAL	xtrans:dword 
local	ytrans:dword 
local	ztrans:dword
LOCAL	sceneroty:dword 
local	count:DWORD

        mov	hWin,rcx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY
        cmp	edx,WM_KEYDOWN
	je      wmKEYDOWN          
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY:invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hRC
	invoke	ReleaseDC,hWin,hDC
	mov	ecx,texture
	invoke	GlobalFree
	mov	eax,sector1
	invoke	GlobalFree
	invoke	RtlExitUserProcess,NULL
;------------------------------
wmKEYDOWN:mov	al,r8b;wParam
	cmp	al,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	cmp	al,VK_B
	jne	@f
	mov	ecx,GL_BLEND
	xor	blend,1
	jz	@1
	invoke	glDisable
	invoke	glEnable,GL_DEPTH_TEST
	jmp	@0
@1:	invoke	glEnable
	invoke	glDisable,GL_DEPTH_TEST
	jmp	@0
@@:	cmp	al,VK_F
	jne	@f
	inc	filter
	jnp	@0;	if (filter>2)
	and	filter,0
	jmp	@0
@@:	cmp	al,VK_PRIOR
	jne	@f
	movd	xmm0,z
	subss	xmm0,const0_02;z-=0.02
	movd	z,xmm0
	movd	xmm0,lookupdown
	subss	xmm0,const1
	movd	lookupdown,xmm0
	jmp	@0
@@:     cmp	al,VK_NEXT
	jne	@f
	movd	xmm0,z
	addss	xmm0,const0_02;z+=0.02
	movd	z,xmm0
	movd	xmm0,lookupdown
	addss	xmm0,const1
	movd	lookupdown,xmm0
	jmp	@0
@@:	cmp	al,VK_UP
	jne	@f
	movd	xmm0,heading
	mulss	xmm0,piover180
	movd	w,xmm0
	invoke	sinf
	mulss	xmm0,const0_05
	movd	xmm1,xpos
	subss	xmm1,xmm0
	movd	xpos,xmm1;xpos -= (float)sin(heading*piover180) * 0.05
	movd	xmm0,w
	invoke	cosf
	mulss	xmm0,const0_05
	movd	xmm1,zpos
	subss	xmm1,xmm0
	movd	zpos,xmm1;zpos -= (float)cos(heading*piover180) * 0.05
	movd	xmm0,walkbiasangle
	comiss	xmm0,const359
	jna	@3;if (walkbiasangle >= 359.0f)
	xorps	xmm0,xmm0;walkbiasangle = 0.0f;
	jmp	@4
@3:	addss	xmm0,const10;walkbiasangle+= 10;
@4:	movd	walkbiasangle,xmm0
	mulss	xmm0,piover180
	invoke	sinf
	mulss	xmm0,const0_05
	movd	walkbias,xmm0;walkbias = (float)sin(walkbiasangle * piover180)/20.0
	jmp	@0
@@:     cmp	al,VK_DOWN
	jne	@f
       	movd	xmm0,heading
	mulss	xmm0,piover180
	movd	w,xmm0
	invoke	sinf
	mulss	xmm0,const0_05
	movd	xmm1,xpos
	addss	xmm1,xmm0
	movd	xpos,xmm1;xpos += (float)sin(heading*piover180) * 0.05
	movd	xmm0,w
	invoke	cosf
	mulss	xmm0,const0_05
	movd	xmm1,zpos
	addss	xmm1,xmm0
	movd	zpos,xmm1;zpos += (float)cos(heading*piover180) * 0.05
	movd	xmm0,walkbiasangle
	comiss	xmm0,const1
	ja	@5;if (walkbiasangle <= 1.0)
	movd	xmm0,const359;walkbiasangle = 359.0
	jmp	@6
@5:	subss	xmm0,const10;walkbiasangle -= 10
@6:     movd	walkbiasangle,xmm0
        mulss	xmm0,piover180
	invoke	sinf
	mulss	xmm0,const0_05
	movd	walkbias,xmm0;walkbias = (float)sin(walkbiasangle * piover180)/20.0
	jmp	@0
@@:     cmp	al,VK_RIGHT
	jne	@f
	movd	xmm0,heading
	subss	xmm0,const1;heading -= 1.0
	movd	heading,xmm0
	movd	yrot,xmm0;yrot = heading
	jmp	@0
@@:	cmp	al,VK_LEFT
	jne	@f
	movd	xmm0,heading
	addss	xmm0,const1;	heading += 1.0f;	
	movd	heading,xmm0
	movd	yrot,xmm0;yrot = heading
	jmp	@0
@@:	cmp	al,VK_PRIOR
	jne	@f
	movd	xmm0,lookupdown
	subss	xmm0,const1;lookupdown-= 1.0
	movd	lookupdown,xmm0
	jmp	@0
@@:	cmp	al,VK_NEXT
	jne	@f
	movd	xmm0,lookupdown
	movd	xmm1,const1
	addss	xmm0,xmm1;lookupdown+= 1.0
	movd	lookupdown,xmm0
@0:	invoke	InvalidateRect,,0,0
        jmp	wmBYE
;-----------------------------------------	
wmCREATE:invoke	GetDC ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hRC,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;-------------------------------------------------------
	mov	ecx,offset FileName2
	invoke	CreateFile,,GENERIC_READ,0,0,OPEN_EXISTING,\
        FILE_FLAG_SEQUENTIAL_SCAN,0;;FILE_ATTRIBUTE_ARCHIVE,0
        mov	esi,eax
        invoke	GetFileSize,eax,0
        mov	FSize,eax
	inc	eax				; Append a 0 char
	invoke	GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,eax
	mov	texture,eax
        mov	edi,eax
	lea	r9d,szReadWrite
        invoke	ReadFile,esi,eax,FSize,,rbx
        invoke	CloseHandle,esi
	mov	esi,edi
        add	esi,[rdi + BITMAPFILEHEADER.bfOffBits]
	lea	edi,[rdi + sizeof BITMAPFILEHEADER]
	mov	eax,[rdi + BITMAPINFOHEADER.biWidth]
        mov	w,eax
        movzx	eax, word ptr [rdi + BITMAPINFOHEADER.biHeight]
        mov	h,eax
;--------------------------------------------------------------
	mov	edx,offset Texture1_Id
	invoke	glGenTextures,3
;    
	mov	edx,Texture1_Id[0*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST
	mov	edx,Texture1_Id[1*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r9d,w
        mov	eax,h
	invoke	glTexImage2D,GL_TEXTURE_2D,0,3,,rax,rbx,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR
	mov	edx,Texture1_Id[2*4]
	invoke	glBindTexture,GL_TEXTURE_2D
	mov	r8d,w
        mov	eax,h
	invoke	gluBuild2DMipmaps,GL_TEXTURE_2D,3,,rax,GL_BGR_EXT,GL_UNSIGNED_BYTE,rsi
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR
	invoke	glTexParameteri,GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_NEAREST

        invoke	glEnable,GL_TEXTURE_2D;enable texture mapping (the img is 2D)
        invoke	glBlendFunc,GL_SRC_ALPHA,GL_ONE; Set The Blending Function For Translucency	
	xorps	xmm3,xmm3
	xorps	xmm2,xmm2
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glClearColor; This Will Clear The Background Color To Black
        cvtss2sd xmm0,const1
	invoke	glClearDepth;Enables Clearing Of The Depth Buffer
        invoke	glDepthFunc,GL_LESS; The Type Of Depth Test To Do
	invoke	glEnable,GL_DEPTH_TEST ;Enables Depth Testing
	invoke	glShadeModel,GL_SMOOTH;smooth shading
;     ()
	invoke	glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST

	invoke	SetupWorld
        mov	r9d,(WINDOWHEIGHT shl 16)or WINDOWWIDTH 
wmSIZE:; --------------- Resize the scene
	movzx	r8,r9w
	mov	w,r8d
	shr	r9d,16
	mov	h,r9d
	invoke	glViewport,0,0;     
        invoke	glMatrixMode,GL_PROJECTION;     
	invoke	glLoadIdentity;		   
;    , ..    (  glcall ..     8 )
	movq	xmm3,constd100
	movq	xmm2,constd0_1
	cvtsi2sd xmm1,w
	cvtsi2sd xmm0,h
	divsd	xmm1,xmm0
	movq	xmm0,constd45
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
	invoke	glLoadIdentity		;   
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
	lea	edx,ps
	invoke  BeginPaint
; --------------- Display the scene
;  
	invoke	glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke	glLoadIdentity
	xorps	xmm0,xmm0
	subss	xmm0,xpos
	movd	xtrans,xmm0;GLfloat xtrans = -xpos;
	xorps	xmm0,xmm0
	subss	xmm0,zpos
	movd	ztrans,xmm0;GLfloat ztrans = -zpos;
	xorps	xmm0,xmm0
	subss	xmm0,walkbias
	subss	xmm0,const0_25
	movd	ytrans,xmm0;GLfloat ytrans = -walkbias-0.25f;
	movd	xmm0,const360
	subss	xmm0,yrot
	movd	sceneroty,xmm0;GLfloat sceneroty = 360.0f - yrot;

	xorps	xmm2,xmm2
	movd	xmm1,const1
	movd	xmm0,lookupdown
	invoke	glRotatef
	xorps	xmm3,xmm3
	movd	xmm2,const1
	xorps	xmm1,xmm1
	movd	xmm0,sceneroty
	invoke	glRotatef
	
	movd	xmm2,ztrans
	movd	xmm1,ytrans
	movd	xmm0,xtrans
	invoke	glTranslatef
	movzx	eax,filter
	mov	edx,Texture1_Id[rax*4]
	invoke	glBindTexture,GL_TEXTURE_2D
; Process Each Triangle
	xor	esi,esi
@@:	invoke	glBegin,GL_TRIANGLES
	movss	xmm2,const1
	xorps	xmm1,xmm1
	xorps	xmm0,xmm0
	invoke	glNormal3f;( 0.0f, 0.0f, 1.0f);
	mov	ecx,sector1
	mov	eax,[rsi+rcx].TRIANGLE.vertex[0*20].x
	mov	x_m,eax
	mov	eax,[rsi+rcx].TRIANGLE.vertex[0*20].y
	mov	y_m,eax
	mov	eax,[rcx+rsi].TRIANGLE.vertex[0*20].z
	mov	z_m,eax
	movd	xmm0,[rcx+rsi].TRIANGLE.vertex[0*20].u
	movd	u_m,xmm0
	movd	xmm1,[rcx+rsi].TRIANGLE.vertex[0*20].v_
	movd	v_m,xmm1
	invoke	glTexCoord2f
	movd	xmm2,z_m
	movd	xmm1,y_m
	movd	xmm0,x_m
	invoke	glVertex3f
	mov	ecx,sector1
	mov	eax,[rcx+rsi].TRIANGLE.vertex[1*20].x			
	mov	x_m,eax
	mov	eax,[rcx+rsi].TRIANGLE.vertex[1*20].y
	mov	y_m,eax
	mov	eax,[rcx+rsi].TRIANGLE.vertex[1*20].z
	mov	z_m,eax
	movd	xmm0,[rcx+rsi].TRIANGLE.vertex[1*20].u
	movd	u_m,xmm0
	movd	xmm1,[rcx+rsi].TRIANGLE.vertex[1*20].v_
	movd	v_m,xmm1
	invoke	glTexCoord2f
	movd	xmm2,z_m
	movd	xmm1,y_m
	movd	xmm0,x_m
	invoke	glVertex3f
	mov	ecx,sector1
	mov	eax,[rcx+rsi].TRIANGLE.vertex[2*20].x
	mov	x_m,eax
	mov	eax,[rcx+rsi].TRIANGLE.vertex[2*20].y
	mov	y_m,eax
	mov	eax,[rcx+rsi].TRIANGLE.vertex[2*20].z
	mov	z_m,eax
	movd	xmm0,[rcx+rsi].TRIANGLE.vertex[2*20].u
	movd	u_m,xmm0
	movd	xmm1,[rcx+rsi].TRIANGLE.vertex[2*20].v_
	movd	v_m,xmm1
	invoke	glTexCoord2f
	movd	xmm2,z_m
	movd	xmm1,y_m
	movd	xmm0,x_m
	invoke	glVertex3f
	invoke	glEnd
	add	esi,sizeof TRIANGLE
	cmp	esi,count2
	jb	@b

	invoke  glFlush
;   
        invoke	SwapBuffers,hDC
        lea	edx,ps
	invoke  EndPaint,hWin
wmBYE:	leave
	retn	
WndProc	endp
SetupWorld proc
local	x:dword 
local	y:dword
local	z:dword
local	u:dword
local	v_:dword
local	numtriangles:dword
local	hFile:dword
local	outline[255]:byte
local	pMemory:dword
local	FSize:dword
local	szReadWrite:dword	;number of bytes actually read or write
local	flag:byte
local	count1:dword
;        filein = fopen("data/world.txt", "rt"); File To Load World Data From
	mov	ecx,offset FileName3
        invoke	CreateFile,,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,rbx,rbx
	mov	hFile,eax
        invoke	GetFileSize,eax,0
        inc	eax
	mov	FSize,eax
        invoke	GlobalAlloc,GPTR,eax
        mov	pMemory,eax
	mov	r8d,FSize
	dec	r8d
	lea	r9d,szReadWrite
        invoke	ReadFile,hFile,eax,,,rbx
	invoke	CloseHandle,hFile
	mov	count1,0
	mov	esi,pMemory
	mov	ecx,FSize
@2:	xor	edx,edx
	lea	edi,outline
@@:	lodsb
	stosb
	inc     edx
	cmp	al,0Ah
	jnz	@b
	cmp	edx,1; ,        
	jz	@2
	lea	r8d,numtriangles
	mov	edx,offset aNUMPOLLIES
	lea	ecx,outline
	invoke	sscanf
	imul	eax,numtriangles,sizeof TRIANGLE;60
	mov	count2,eax
	invoke	GlobalAlloc,GPTR,eax
	mov	sector1,eax

@4:	and	flag,0	
	xor	edx,edx
	lea	edi,outline
@@:	lodsb
	stosb
	inc	edx
	cmp	al,0Ah
	jz      @3
	cmp	al,"/"
	jnz	@b
	or	flag,1
	jmp	@b
@3:	cmp	edx,1
	jz	@4
	cmp	flag,1
	jz	@4
	mov	ecx,count1
	add	ecx,sector1
	lea	eax,[rcx].TRIANGLE.vertex.v_
	mov	[rsp+30h],rax
	lea	eax,[rcx].TRIANGLE.vertex.u
	mov	[rsp+28h],rax
	lea	eax,[rcx].TRIANGLE.vertex.z
	mov	[rsp+20h],rax
	lea	r9d,[rcx].TRIANGLE.vertex.y
	lea	r8d,[rcx].TRIANGLE.vertex.x
	mov	edx,offset fmt
	lea	ecx,outline
	invoke	sscanf
	add	count1,sizeof VERTEX;20
	mov	eax,count1
	cmp	eax,count2
	jb	@4
	mov	ecx,pMemory
	invoke	GlobalFree
	leave
	ret
SetupWorld endp
;---------------------------------------------------------------------------
hDC	dq	?
hRC	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR
  	nVersion          dw	1
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or PFD_DRAW_TO_WINDOW
  	iPixelType        db	PFD_TYPE_RGBA
  	cColorBits        db	32;Select Our Color Depth
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;Color Bits Ignored
  	cAlphaBits        db	0;No Alpha Buffer
  	cAlphaShift       db	0;Shift Bit Ignored
  	cAccumBits        db	0;No Accumulation Buffer
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;Accumulation Bits Ignored
  	cDepthBits        db	16;16Bit Z-Buffer (Depth Buffer)
  	cStencilBits      db	0;No Stencil Buffer
  	cAuxBuffers       db	0;No Auxiliary Buffer
  	iLayerType        db	PFD_MAIN_PLANE;Main Drawing Layer
  	bReserved         db	0;Reserved
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;Layer Masks Ignored

szClassName	db "NeHe lesson#10: Loading and Moving Through a 3D-World",0
FileName	db "br_Rabbit3.cur",0
FileName2	db "mud.bmp",0
FileName3	db "world.txt",0
aNUMPOLLIES	db "NUMPOLLIES %d\n",0
fmt		db "%f %f %f %f %f",0
texture		dd ?
Texture1_Id	dd ?,?,?;Storage For 3 Textures
blend		db FALSE; Blending ON/OFF
heading		dd ?;
xpos		dd ?;
zpos		dd ?;
yrot		dd ?; Y Rotation
walkbias 	dd 0;
walkbiasangle	dd 0;
lookupdown	dd 0
z		dd 0; Depth Into The Screen
filter		db 0
count2		dd ?
;-----------------------------
;float
piover180	dd 0.0174532925199432957692369077;pi/180
const0_02 	dd 0.02
const0_05	dd 0.05
const0_25	dd 0.25
const1		dd 1.0
const10		dd 10.0
const359	dd 359.0
const360	dd 360.0
;double
constd0_1	dq 0.1
constd45	dq 45.0
constd100	dq 100.0
sector1 	dd ?; Our Model Goes Here
end